/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _TEXTURE_LAYER_H_
#define _TEXTURE_LAYER_H_

#include "imagePng.h"
#include "shaderManager.h"


enum textureType {COLOR_MAP, NORMAL_MAP, GLOSS_MAP, EMISSION_MAP, OTHER_MAP};

class TextureLayer
{
	public:
		TextureLayer(ImagePng *image, textureType type, GLenum wrapMode, bool mipmaps);
		TextureLayer(int width, int height); //for rendering to texture with a FBO
		~TextureLayer();
		
		textureType getType();
		GLenum getId();
		
		void setBlendMode(GLenum blendMode);
		void setScale(float scaleS, float scaleT);
		
		void activate();
		void release();
	
	private:
		GLenum mBlendMode;
		GLenum mWrapMode;
		GLenum mMinMode;
		GLenum mMagMode;
		
		float mScaleS, mScaleT;
		
		GLuint id;
		
		textureType mType;
};


#endif // _TEXTURE_LAYER_H_

